from socket_utils import *

# This one passes intense stress tests ("Industrial strength")
servsock = socket.socket( socket.AF_INET, socket.SOCK_STREAM )
servsock.bind(("", 12345))     # bind to all local host interfaces
servsock.listen(25)            # set maximum accept rate to 25 connections

id = 0             # connection id
while True:        # Server infinite loop
    newsock, address = servsock.accept()
    id += 1
    start = time.time()%1000
    # receive file name delimited by newline char
    file = recv_delimited_message(newsock)
    if os.path.exists(file):
         newsock.sendall("READY")
    else:
         print "File not found:", file
         newsock.sendall("ERROR")
         newsock.close()
         continue
    fsize = int( os.path.getsize(file) )
    newsock.sendall(str(fsize) + '\n')
    # receive file transfer confirmation ("OK")
    ok = recv_fixed_size(newsock, 2)
    print ok
    # now we are sending the full file data!
    send_file(newsock, file, 'rb')
    # getting file transfer confirmation from client (DONE or FAIL)
    response = recv_fixed_size(newsock, 4)
    if response == "DONE":
        print "Transfer confirmed:", response
    elif response == "FAIL":
        print "File transfer failed"

    end = time.time()%1000
    print "Connection %d: File = %s, Time = %.2f-%.2f" % (id, file, start, end)
    newsock.close()

