from socket_utils import *

servsock = socket.socket( socket.AF_INET, socket.SOCK_STREAM )

servsock.bind(("", 12345))     # bind to all local host interfaces
servsock.listen(25)            # set maximum accept rate to 25 connections

print "HOST IP =", getIPaddress()

############################################################
# send_file:
#     Start a new thread for sending a file through a socket
# protocol:
#     If file exists and readable:
#         send "READY" to the client (so he knows his file is OK)
#         send the file by the SockSendFile thread class
#     else:
#         send "ERROR"
############################################################

def send_file_thread(file, sock, mode='rb', bufsize=4096):
    if not os.path.isfile(file):                # Is this a normal file?
        print "File not found:", file           # server print
        sock.sendall("404 File not found\n")    # client send
        return None
    elif not os.access(file, os.R_OK):          # File not readable
        print "File not readable:", file        # server side
        sock.sendall("401 File not readable\n") # client send
        return None
    else:
        print "File OK:", file                      # server side
        sock.sendall("200 File OK: sending now\n")  # client side
        thread = SendFileThread(sock, file, mode, bufsize)
        return thread

### Server Loop
while True:
    newsock, address = servsock.accept()
    date = time.ctime()
    host,port = address
    print "Connected to client host=%s, port=%d, DATE: %s" % (host, port, date)
    file = recv_delimited_message(newsock)    # returns None if not receiving full message
    if file is None:
        newsock.close()
        continue
    thread = send_file_thread(file, newsock)
    if thread is None:
        newsock.close()
    else:
        thread.start()

