from socket_utils import *

#bufsize = 4096
bufsize = 2**14
remote_file = "c:/workspace/oliver.txt"
#remote_file = "c:/workspace/db.csv"
start = time.time()
num_tests = 20
passed_tests = 0

# Transfer:
# remote_file (from file_server port 12345) ==> local_file (on local host)
def get_file(remote_file, local_file):
    sock = socket.socket( socket.AF_INET, socket.SOCK_STREAM )
    sock.connect(("localhost", 12345))
    sock.sendall(remote_file + '\n')
    #fsize = sock.recv(1024)  ---  this is not safe!
    fsize = int( recv_delimited_message(sock) )   # expected file size, must be converted to integer!
    #print "fsize =", fsize   ---  debug message
    sock.sendall('OK')
    recv_fixed_size_to_file(sock, fsize, local_file, 'wb')
    if os.path.getsize(local_file) == fsize:
        print "Received file:", local_file
        sock.sendall('DONE')
    else:
        print "Receive error: size does not match", local_file
        sock.sendall('BAD')
    sock.close()

for i in range(0, num_tests):
    local_file = "c:/workspace/local%d.txt" % (i)
    if os.path.exists(local_file):
        os.remove(local_file)
    get_file(remote_file, local_file)
    print "size =", os.path.getsize(local_file)
    if files_equal(remote_file, local_file):
        passed_tests += 1
    else:
        print "FAILED test:", i, local_file

end = time.time()

print "Summary: passed %s tests out of %s tries" % (passed_tests, num_tests)
size = os.path.getsize(remote_file)
throughput = (size * num_tests) / (end - start)
print "THROUGHPUT = %.2f MB per second" %    (throughput / 1024**2)


