import os, subprocess
from socket_utils import *
from file_client_4 import get_file_thread

##### Global Paramters
#file_server = "localhost:12345"
file_server = "192.168.56.1:12345"
bufsize = 4096
#bufsize = 2**14
#remote_file = "c:/workspace/oliver.txt"
remote_file = "c:/workspace/db.csv"
num_tests = 16
passed_tests = 0
start = time.time()
traffic = 0        # Number of bytes travelling from server to client
thread = {}        # we are going to build a dictionary of threads ! ...

##### Monitoring Tools
os.startfile("c:/workspace")          # View how files are growing in size
try:                                  # Start Windows Resource Monitor Tool
    subprocess.Popen(['resmon.exe'])
except:
    print "Resource monitor could not be loaded in your system :-("

print "Transfer %d many copies of remote file %s to c:/workspace" % (num_tests, remote_file)

##### Quality Checks
for i in range(num_tests):
    local_file = "c:/workspace/copy%d.txt" % (i)
    if os.path.exists(local_file):
        os.remove(local_file)
    thread[i] = get_file_thread(file_server , remote_file, local_file)
    print "\nRemote: %s => Local: %s" % (remote_file, local_file)

# Wait for all threads to end
for i in range(num_tests):
    thread[i].join()

print "Finished getting all files !"
end = time.time()

print "Checking if files are identical to original master file ..."
for i in range(num_tests):
    local_file = thread[i].file
    traffic += os.path.getsize(local_file)
    if files_equal(local_file, remote_file):
        passed_tests += 1
    else:
        print "FAILED test: %s != %s" % (local_file, remote_file)

print "Summary: passed %s tests out of %s tries" % (passed_tests, num_tests)
throughput = traffic / (end - start)
print "THROUGHPUT = %.2f MB per second" %    (throughput / 1024**2)


